@echo off
:: I can't write a makefile, so this will have to do. -uso.

:: cpu65c02 dependencies: cpu65c02.c, dapple.h, asmlib.h
newer cpu65c02.o cpu65c02.c
if errorlevel 1 goto b_cpu65c02
newer cpu65c02.o dapple.h
if errorlevel 1 goto b_cpu65c02
newer cpu65c02.o asmlib.h
if errorlevel 1 goto b_cpu65c02
goto dapple
:b_cpu65c02
ECHO Compiling cpu65c02.c ...
redir -o cpu65c02.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c cpu65c02.c
if errorlevel 1 goto gccerr

:dapple
:: dapple dependencies: dapple.c, dapple.h, asmlib.h
newer dapple.o dapple.c
if errorlevel 1 goto b_dapple
newer dapple.o dapple.h
if errorlevel 1 goto b_dapple
newer dapple.o asmlib.h
if errorlevel 1 goto b_dapple
goto disk
:b_dapple
ECHO Compiling dapple.c ...
redir -o dapple.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c dapple.c
if errorlevel 1 goto gccerr

:disk
:: disk dependencies: disk.c, dapple.h, asmlib.h
newer disk.o disk.c
if errorlevel 1 goto b_disk
newer disk.o dapple.h
if errorlevel 1 goto b_disk
newer disk.o asmlib.h
if errorlevel 1 goto b_disk
goto ini
:b_disk
ECHO Compiling disk.c ...
redir -o disk.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c disk.c
if errorlevel 1 goto gccerr

:ini
:: ini dependencies: ini.c, dapple.h
newer ini.o ini.c
if errorlevel 1 goto b_ini
newer ini.o dapple.h
if errorlevel 1 goto b_ini
goto lldisk
:b_ini
ECHO Compiling ini.c ...
redir -o ini.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c ini.c
if errorlevel 1 goto gccerr

:lldisk
:: lldisk dependencies: lldisk.c, dapple.h, asmlib.h
newer lldisk.o lldisk.c
if errorlevel 1 goto b_lldisk
newer lldisk.o dapple.h
if errorlevel 1 goto b_lldisk
newer lldisk.o asmlib.h
if errorlevel 1 goto b_lldisk
goto memory
:b_lldisk
ECHO Compiling lldisk.c ...
redir -o lldisk.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c lldisk.c
if errorlevel 1 goto gccerr

:memory
:: memory, rwmemory and dymemory dependencies: memory.c, dapple.h, asmlib.h
newer memory.o memory.c
if errorlevel 1 goto b_memory
newer memory.o dapple.h
if errorlevel 1 goto b_memory
newer memory.o asmlib.h
if errorlevel 1 goto b_memory
newer rwmemory.o memory.c
if errorlevel 1 goto b_memory
newer rwmemory.o dapple.h
if errorlevel 1 goto b_memory
newer rwmemory.o asmlib.h
if errorlevel 1 goto b_memory
newer dymemory.o memory.c
if errorlevel 1 goto b_memory
newer dymemory.o dapple.h
if errorlevel 1 goto b_memory
newer dymemory.o asmlib.h
if errorlevel 1 goto b_memory
goto pic
:b_memory
ECHO Compiling memory.c ...
ECHO (Pass 1: Without RAM Works)
redir -o memory.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c memory.c
if errorlevel 1 goto gccerr
echo (Pass 2: With RAM Works)
redir -o rwmemory.err -eo gcc -o rwmemory.o -Wall -O3 -DRAMWORKS_3MEG -fomit-frame-pointer -s -c memory.c
if errorlevel 1 goto gccerr
echo (Pass 3: With Dynamic RAM Works)
redir -o dymemory.err -eo gcc -o dymemory.o -Wall -O3 -DDYNRAM -DRAMWORKS_3MEG -fomit-frame-pointer -s -c memory.c
if errorlevel 1 goto gccerr

:pic
:: pic dependencies: pic.c
newer pic.o pic.c
if errorlevel 1 goto b_pic
goto video
:b_pic
ECHO Compiling pic.c ...
redir -o pic.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c pic.c
if errorlevel 1 goto gccerr

:video
:: video dependencies: video.c, dapple.h, asmlib.h
newer video.o video.c
if errorlevel 1 goto b_video
newer video.o dapple.h
if errorlevel 1 goto b_video
newer video.o asmlib.h
if errorlevel 1 goto b_video
newer video.o font.h
if errorlevel 1 goto b_video
goto linktop
:b_video
ECHO Compiling video.c ...
redir -o video.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c video.c
if errorlevel 1 goto gccerr

:linktop
:: dapple2.exe and dapple2r.exe dependencies
newer dapple2.exe asmlib.o
if errorlevel 1 goto golink
newer dapple2.exe cpu65c02.o
if errorlevel 1 goto golink
newer dapple2.exe dapple.o
if errorlevel 1 goto golink
newer dapple2.exe disk.o
if errorlevel 1 goto golink
newer dapple2.exe ini.o
if errorlevel 1 goto golink
newer dapple2.exe lldisk.o
if errorlevel 1 goto golink
newer dapple2.exe memory.o
if errorlevel 1 goto golink
newer dapple2.exe pic.o
if errorlevel 1 goto golink
newer dapple2.exe video.o
if errorlevel 1 goto golink

newer dapple2r.exe asmlib.o
if errorlevel 1 goto golink
newer dapple2r.exe cpu65c02.o
if errorlevel 1 goto golink
newer dapple2r.exe dapple.o
if errorlevel 1 goto golink
newer dapple2r.exe disk.o
if errorlevel 1 goto golink
newer dapple2r.exe ini.o
if errorlevel 1 goto golink
newer dapple2r.exe lldisk.o
if errorlevel 1 goto golink
newer dapple2r.exe rwmemory.o
if errorlevel 1 goto golink
newer dapple2r.exe pic.o
if errorlevel 1 goto golink
newer dapple2r.exe video.o
if errorlevel 1 goto golink

newer dapple2d.exe asmlib.o
if errorlevel 1 goto golink
newer dapple2d.exe cpu65c02.o
if errorlevel 1 goto golink
newer dapple2d.exe dapple.o
if errorlevel 1 goto golink
newer dapple2d.exe disk.o
if errorlevel 1 goto golink
newer dapple2d.exe ini.o
if errorlevel 1 goto golink
newer dapple2d.exe lldisk.o
if errorlevel 1 goto golink
newer dapple2d.exe dymemory.o
if errorlevel 1 goto golink
newer dapple2d.exe pic.o
if errorlevel 1 goto golink
newer dapple2d.exe video.o
if errorlevel 1 goto golink

echo (Your Dapple ][ binaries are already up-to-date.)
goto absend

:golink
ECHO Linking dapple2.exe ...
echo (Pass 1: Without RAM Works)
redir -o link1.err -eo gcc -s -o dapple2.exe asmlib.o cpu65c02.o dapple.o disk.o ini.o lldisk.o memory.o pic.o video.o
if errorlevel 1 goto linkerr
echo (Pass 2: With RAM Works)
redir -o link2.err -eo gcc -s -o dapple2r.exe asmlib.o cpu65c02.o dapple.o disk.o ini.o lldisk.o rwmemory.o pic.o video.o
if errorlevel 1 goto linkerr
echo (Pass 3: With Dynamic RAM Works)
redir -o link3.err -eo gcc -s -o dapple2d.exe asmlib.o cpu65c02.o dapple.o disk.o ini.o lldisk.o dymemory.o pic.o video.o
if errorlevel 1 goto linkerr

ECHO Add DOS-Extender...
:: Change the directory to reflect the location of your stubit.exe file
e:\wdosx\bin\stubit dapple2.exe
e:\wdosx\bin\stubit dapple2r.exe
e:\wdosx\bin\stubit dapple2d.exe
del dapple2.bak
del dapple2r.bak
del dapple2d.bak
GOTO end

:gccerr
ECHO Error in C file
GOTO end

:linkerr
ECHO Link error

:end
prtwhead *.err>error.log
del *.err

:absend
